routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('equipments','EquipmentController');
Route::resource('units','UnitController');
Route::resource('rentrequests','RentrequestController');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Unit.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Unit extends Model
{
	protected $guarded = [];
    
    public function equipment(){
    	return $this->belongsTo('App\Equipment','equipment_id');
    }

    public function status(){
    	return $this->belongsTo('App\Rentable_Status','rentable_status_id');
    }
}

app/Http/Controllers/UnitController.php
<?php

namespace App\Http\Controllers;

use App\Unit;
use App\Equipment;
use App\Rentable_Status;
// use App\Request\UnitRequest;
use Illuminate\Http\Request;

class UnitController extends Controller
{

    // public function addAll($equipments,$statuses,$units){
    //     $equipments = Equipment::all();
    //     $statuses = Rentable_Status::all();
    //     $units = Unit::all();

       

    // }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
  
        $equipments = Equipment::all();
        $statuses = Rentable_Status::all();


        return view('admin.units.index', compact('equipments'))
                 ->with('status',$statuses);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // $this->authorize('create',$unit);
        $equipments = Equipment::all();
        $units = Unit::all();
        $statuses = Rentable_Status::all();

        return view('admin.units.create', compact('equipments'))
                 ->with('status',$statuses)
                 ->with('unit',$units);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request , Unit $unit, Equipment $equipment)
    {
        
        
        $request->validate([
                    'name' => 'string|required',
                    'manufacturer' =>'string|required',
                    'year_model'  =>'numeric|required',
                    'description'  =>'string|required',
                    'rent_price'  =>'numeric|required',
                    'photo' =>'image|max:5000',
                    'equipment_id' =>'numeric|required'
                ]);




        $equipment_id = $request->input('equipment_id');
        $equipment = Equipment::find($equipment_id);

      
        // Save and Update Database
        $units = Unit::create($request->all());
        $equipment->current_available += 1;
        $equipment->save();

       


        if($units) {
            return redirect('units')->with('success', 'A unit was succesfully created!');
        }
        return redirect('units')->with('error', 'Unit not created!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Unit  $unit
     * @return \Illuminate\Http\Response
     */
    public function show(Unit $unit)
    {
        $units = Unit::all();
        $color = 'table-warning';

        // color switching condition
        // dd($unit->status->id);
        if($unit->status->id !== 1)
        {
            $color = 'table-danger'; 
        }



        // dd($unavailable);
        return view('admin.units.show',compact('unit'))
            ->with('units',$units)
            ->with('color',$color);


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Unit  $unit
     * @return \Illuminate\Http\Response
     */
    public function edit(Equipment $equipment, Unit $unit)
    {
        $units = Unit::all();
        $equipments = Equipment::all();
        $statuses = Rentable_Status::all();

        $equipment_option = $unit->equipment->id;
        $status_option = $unit->status->id;

        $color = 'table-warning';

        if($unit->status->id !== 1)
        {
            $color = 'table-danger'; 
        }

        return view('admin.units.edit')
               ->with('equipment',$equipment)
               ->with('equipments',$equipments)
               ->with('statuses',$statuses)
               ->with('units',$units)
               ->with('unit',$unit)
               ->with('equipment_option',$equipment_option)
               ->with('status_option',$status_option)
               ->with('color',$color);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Unit  $unit
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Unit $unit)
    {
        

        // $equipment = Equipment::find($unit->equipment->id);
      
        $available = $unit->equipment->current_available;
        $items_out = $unit->equipment->current_out;
        $dbstatus = $unit->rentable_status_id;
        // echo "Old Available: ".$available."   | Old Out: ".$items_out."</br>";

        $request->validate([
                  'name' => 'string|required',
                  'manufacturer' =>'string|required',
                  'year_model'  =>'numeric|required',
                  'description'  =>'string|required',
                  'rent_price'  =>'numeric|required',
                  'photo' =>'image|max:5000',
                  'equipment_id' =>'numeric|required',
                  'rentable_status_id' =>'numeric|required'
                ]);


        $unit->name = $request->input('name');
        $unit->manufacturer = $request->input('manufacturer');
        $unit->year_model = $request->input('year_model');
        $unit->description = $request->input('description');
        $unit->rent_price = $request->input('rent_price');
        $unit->equipment_id = $request->input('equipment_id');
        $unit->rentable_status_id = $request->input('rentable_status_id');

        if($dbstatus == 1 && $unit->rentable_status_id !== 1)
        {
            $available -=1; 
            $items_out +=1;
        }
        elseif ($dbstatus !== 1 && $unit->rentable_status_id == 1) {
            $items_out -=1;
            $available +=1; 
        }
        else
        {
            $available = $unit->equipment->current_available;
            $items_out = $unit->equipment->current_out;
        }

        // echo "New Available: ".$available."   | New Out: ".$items_out."</br>";

        // dd($unit->equipment);

        $unit->equipment->current_available = $available;
        $unit->equipment->current_out = $items_out;
        $unit->equipment->save();



        $unit->save();
        $request->session()->flash('status','Update Successful');
       
       if($request) {
           return redirect('units')->with('success', 'A unit was succesfully created!');
       }
       return redirect('units')->with('error', 'Unit not created!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Unit  $unit
     * @return \Illuminate\Http\Response
     */
    public function destroy(Unit $unit, Request $request)
    {
        
        // declarations
        $available = $unit->equipment->current_available;
        $items_out = $unit->equipment->current_out;
        $dbstatus = $unit->rentable_status_id;

        // dd($dbstatus);
        // condition to check current stocks
        if($dbstatus == 1)
        {
            $available -=1; 
            // $items_out +=1;
        }
        elseif ($dbstatus !== 1) {
            $items_out -=1;
            // $available +=1; 
        }
        else
        {
            $available = $unit->equipment->current_available;
            $items_out = $unit->equipment->current_out;
        }

        // update stocks
        $unit->equipment->current_available = $available;
        $unit->equipment->current_out = $items_out;
        $unit->equipment->save();


        $unit->delete();
        return redirect('units')->with('success', 'A unit was succesfully deleted!');
    }
}

resources/views/admin/units/create.blade.php
{{-- Create -> Store New Unit to Db --}}
{{-- create.blade.php --}}


@extends('layouts.app')
@section('content')


<div class="container">
	<h1 class="text-center">Create New Unit</h1>
	<hr>
	<div class="row">
		@csrf
		@if($errors->hasAny())
				<div class="alert alert-danger mb-0 p-0">
						{{ $errors }}
				</div>
		@endif
		<div class="col col-12 col-md-8 mx-auto">
				{{-- Start of Card --}}
				<div class="card elegant-color white-text rounded-bottom">
					<img class="card-img-top" src="https://via.placeholder.com/708x472" alt="Unit Image">
			    	<div class="card-body">
					<form action="{{ route('units.store') }}" method="POST" enctype="multipart/form-data">
					@csrf
						<input type="file" name="photo" id="photo" class="form-control-file mb-1">
						<hr>
				    	<input type="text" name="name" id="name" class="form-control mb-1" placeholder="Unit Name" value="">

				    	<input type="text" name="manufacturer" id="manufacturer" class="form-control mb-1" placeholder="Manufacturers Name" value="">

				    	<input type="text" name="year_model" id="year_model" class="form-control mb-1" placeholder="Year Model" value="" max="4" min="4">


				    	<select name="equipment_id" id="equipment_id" class="custom-select">
				    				@foreach($equipments as $equipment)
				    				<option 
				    				value="{{ $equipment->id }}"
				    				{{ old('equipment_id') == $equipment->id ? "selected": "" }} 
				    				{{-- simplified if-else --}}

				    				>

				    				{{ $equipment->name }}
				    				@endforeach()
				    	</select>
						
				    	<input type="text" name="rent_price" id="rent_price" class="form-control mb-1 mt-1" placeholder="Rent Price" value="">

				    	<textarea name="description" id="description" cols="30" rows="10" placeholder="Product Description" class="form-control mb-1"></textarea>

						<button type="submit" class="btn btn-dark">Create New Unit</button>
						</form>
			    	</div>
					
				</div>
				{{-- End Card --}}
			
		</div>
	
		<div class="col col-12 col-md-4 mx-auto">
			<a href="{{ route('units.index') }}"><h2 class="bg-primary text-light text-center rounded p-2 ">VIEW UNITS</h2></a>
			<h2 class="bg-dark text-light text-center rounded p-2 ">STATISTICS</h2>
			<div class="table-responsive rounded">
				<table class="table table-hover ">
					<thead>
						<th class="text-center">LEGEND</th>
						<th class="text-center">FIGURE</th>
					</thead>
					<tbody>

						<tr class="#">
							<td><strong>Status</strong></td>
							<td>{Status}</td>
						</tr>
						<tr>
							<td>Last Rented Date</td>
							<td>{Rented Date}</td>
						</tr>
						<tr>
							<td>Last Used By</td>
							<td>{Rented User}</td>
						</tr>
						<tr>
							<td>Total Times Rented</td>
							<td>{20}</td>
						</tr>
						<tr>
							<td>Gross Income</td>
							<td>&#8369; {{ number_format(150000,2)  }}</td>
						</tr>
						
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>

@endsection

resources/views/admin/units/edit.blade.php
{{-- Units -> Edit --}}
{{-- edit.blade.php --}}

@extends('layouts.app')
@section('content')


<div class="container">
	<h1 class="text-center">Create New Unit</h1>
	<hr>
	<div class="row">
		@csrf
		@if($errors->hasAny())
				<div class="alert alert-danger mb-0 p-0">
						{{ $errors }}
				</div>
		@endif
		<div class="col col-12 col-md-8 mx-auto">
				{{-- Start of Card --}}
				<div class="card elegant-color white-text rounded-bottom">
					<img class="card-img-top" src="https://via.placeholder.com/708x472" alt="Unit Image">
			    	<div class="card-body">

					<form action="{{ route('units.update',[$unit->id]) }}" method="POST" enctype="multipart/form-data">
					@csrf
					@method('PUT')
						<input type="file" name="photo" id="photo" class="form-control-file mb-1" value="">
						<hr>
				    	<input type="text" name="name" id="name" class="form-control mb-1" placeholder="Unit Name" value="{{ $unit->name }}">

				    	<input type="text" name="manufacturer" id="manufacturer" class="form-control mb-1" placeholder="Manufacturers Name" value="{{ $unit->manufacturer }}">

				    	<input type="text" name="year_model" id="year_model" class="form-control mb-1" placeholder="Year Model" max="4" min="4" value="{{ $unit->year_model }}">

						

				    	<select name="equipment_id" id="equipment_id" class="custom-select">
				    		@foreach($equipments as $equipment)
				    			<option value="{{ $equipment->id }}" {{ $equipment_option == $equipment->id ? "selected": "" }}>{{ strtoupper($equipment->name) }}</option>
				    		@endforeach()
				    	</select>

				    	<select name="rentable_status_id" id="rentable_status_id" class="custom-select mt-1">
				    		@foreach($statuses as $status)
				    			<option value="{{ $status->id }}" {{ $status_option == $status->id ? "selected": "" }}>{{ strtoupper($status->name) }}</option>
				    		@endforeach()
				    	</select>
						
				    	<input type="text" name="rent_price" id="rent_price" class="form-control mb-1 mt-1" placeholder="Rent Price" value="{{ $unit->rent_price  }}">

				    	<textarea name="description" id="description" cols="30" rows="10" placeholder="Product Description" class="form-control mb-1">{{ $unit->description }}</textarea>

						<button type="submit" class="btn btn-dark">Update Unit</button>
						</form>
			    	</div>
					
				</div>
				{{-- End Card --}}
			
		</div>
	
		<div class="col col-12 col-md-4 mx-auto">
			<a href="{{ route('units.index') }}"><h2 class="bg-primary text-light text-center rounded p-2 ">VIEW UNITS</h2></a>
			<h2 class="bg-dark text-light text-center rounded p-2 ">STATISTICS</h2>
			<div class="table-responsive rounded">
				<table class="table table-hover ">
					<thead>
						<th class="text-center">LEGEND</th>
						<th class="text-center">FIGURE</th>
					</thead>
					<tbody>

						<tr class="{{ $color }}">
							<td><strong>Status</strong></td>
							<td>{{ strtoupper($unit->status->name) }}</td>
						</tr>
						<tr>
							<td>Last Rented Date</td>
							<td>{Rented Date}</td>
						</tr>
						<tr>
							<td>Last Used By</td>
							<td>{Rented User}</td>
						</tr>
						<tr>
							<td>Total Times Rented</td>
							<td>{20}</td>
						</tr>
						<tr>
							<td>Gross Income</td>
							<td>&#8369; {{ number_format(150000,2)  }}</td>
						</tr>
						
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>

@endsection

resources/views/admin/units/index.blade.php
{{-- Units -> Index/Show All --}}
{{-- index.blade.php --}}

@extends('layouts.app')
@section('content')

<div class="container">
	<div class="row">
		<div class="col-12 col-md-10 mx-auto">
			<h3>LIST OF UNITS </h3>
		</div>
		<div class="col-12 col-md-2 mx-auto">
			<a href="{{ route('units.create') }}" class="btn btn-primary">Add New Unit</a>
		</div>
	</div>
	<hr>
</div>

	{{-- start accordion --}}
@foreach($equipments as $equipment)
<div class="accordion mb-1" id="equipments-group">
	<div class="container">
		<div class="card bg-dark">
			<div class="card-header" id="equipmentsHead">
				<div class="container">
					<div class="row">
						<div class="col col-12 col-md-8 mx-auto">
							<h3 class="text-left text-light">{{ $equipment->name }}</h3>
						</div>
						<div class="col col-12 col-md-4">
							<span class="btn btn-primary">{{ $equipment->current_available + $equipment->current_out }}</span>
							<span class="btn btn-danger">{{ $equipment->current_out }}</span>
							<span class="btn btn-warning">{{ $equipment->current_available }}</span>
							<button class="btn btn-light fas fa-arrow-alt-circle-down" type="button" data-toggle="collapse" data-target="#transaction-{{ $equipment->id }}" aria-expanded="true" aria-controls="collapseOne">
								VIEW LIST
							</button>
						</div>
					</div>
				</div>
			</div>
			{{-- end of equipment group head --}}


			<div id="transaction-{{ $equipment->id }}" class="collapse bg-light" aria-labelledby="equipmentsHead" data-parent="#equipments-group">
				<div class="card-body p-0">
					{{-- start of units cards --}}
					{{-- table starts here --}}
					<div class="table-responsive">
						<table class="table table-bordered text-center">
							<thead class="thead-default">
								<th scope="col col-md-1">No</th>
								<th scope="col col-md-2">Name</th>
								<th scope="col col-md-2">Year Model</th>
								<th scope="col col-md-2">Rent Price</th>
								<th scope="col col-md-2">Status</th>
								<th scope="col col-md-3">Action</th>
							</thead>
							<tbody>
								@foreach($equipment->units as $unit)

								{{-- Start of ROW for Equipments --}}
								<tr>
									<td>{{ $loop->iteration }}</td>
									<td><strong>{{ $unit->name }}</strong></td>
									<td>{{ $unit->year_model }}</td>
									<td>&#8369; {{ number_format($unit->rent_price,2)  }}</td>
									<td>{{ strtoupper($unit->status->name) }}</td>
									<td>
										{{-- View Equipment Details --}}
										<a href="{{ route('units.show',[$unit->id]) }}" class="btn btn-light d-inline">
											<span class="fas fa-eye pr-2 pl-2"></span>
										</a>
										{{-- Edit Equipment Details --}}
										<a href="{{ route('units.edit',[$unit->id]) }}" class="btn btn-light d-inline">
											<span class="fas fa-edit pr-2 pl-2"></span>
											
										</a>
										{{-- Delete Equipment Details --}}
										<form action="{{ route('units.destroy',[$unit->id]) }}" method="POST" class="d-inline">
											@csrf
											@method('DELETE')
											<button type="submit" class="btn btn-light"><span class="fas fa-trash-alt"></span></button>
										</form>
										
										
									</td>
									
								</tr>
								{{-- End of ROW for Equipments --}}
								@endforeach
							</tbody>
						</table>
					</div>
					{{-- table ends here --}}




					{{-- end of units cards --}}
				</div>
			</div>
		</div>
	</div>
</div>
{{-- end of accordion --}}
@endforeach













@endsection

resources/views/admin/units/show.blade.php
{{-- Units -> Show / Display Individual --}}
{{-- show.blade.php --}}

@extends('layouts.app')
@section('content')


<div class="container">
	<h1 class="text-center">{{ $unit->name }}</h1>
	<hr>
	<div class="row">
		<div class="col col-12 col-md-8 mx-auto">
			<!-- Card Dark -->
			<div class="card">

			  <!-- Card image -->
			  <div class="view overlay">
			    <img class="card-img-top" src="https://via.placeholder.com/708x472" alt="Unit Image">
			    <a>
			      <div class="mask rgba-white-slight"></div>
			    </a>
			  </div>

			

			  <!-- Card content -->
			  <div class="card-body elegant-color white-text rounded-bottom">
					<div class="container">
						<div class="row">
							<div class="col-12 col-md-7 mx-auto">
								<h2>{{ $unit->name }}</h2>
								<p class="d-sm-block d-md-inline"><small>Manufactured By: </small><strong class="font-italic">{{ $unit->manufacturer }}</strong></p>
								<p class="pl-md-5 d-sm-block d-md-inline "><small>Year Model: </small><strong class="font-italic">{{ $unit->year_model }}</strong></p>
							</div>
							<div class="col-12 col-md-5 mx-auto">
								{{-- Edit Equipment Details --}}
								<a href="{{ route('units.edit',[$unit->id]) }}" class="btn btn-dark d-inline">Edit <span class="fas fa-edit pr-2 pl-2"></span></a>
								
								{{-- Delete Equipment Details --}}
								<form action="{{ route('units.destroy',[$unit->id]) }}" method="POST" class="d-inline">
									@csrf
									@method('DELETE')
									<button type="submit" class="btn btn-dark pt-1">Delete <span class="fas fa-trash-alt pr-2 pl-2"></span></button>
								</form>
							</div>
						</div>
					</div>
					
				{{-- End Title --}}

				<hr class="hr-light">
				
				{{-- Status --}}
					<div class="container">
						<div class="row">
							<div class="col-12 col-md-7 mx-auto">
								<h2>Rental Price</h2>
							</div>
							<div class="col-12 col-md-5 mx-auto">
								<h2>&#8369; {{ number_format($unit->rent_price,2)  }}</h2>
							</div>
						</div>
					</div>

			    <hr class="hr-light">

			    <!-- Description -->
			    <p class="card-text white-text mb-4">{{ $unit->description }}</p>
				
				
			  </div>
			{{-- End Card Body --}}

			{{-- Start Card Footer --}}

				<div class="card-footer text-muted">
					<div class="text-center">
							<p class="d-sm-block d-md-inline">
								<small>Equipment Group:
									<strong class="font-italic">{{ $unit->equipment->name }}</strong> 
								</small>
								
							</p>
						  	<p class="pl-md-5 pr-md-5 d-sm-block d-md-inline">
						  		<small>Created Last: 
						  			<strong class="font-italic">
						  				{{ date('M j, Y  g:i A', strtotime($unit->created_at)) }}
						  			</strong>
						  		</small>
						  		
						  	</p>
						  	<p class="d-sm-block d-md-inline ">
						  		<small>Updated Last: 
									<strong class="font-italic">
										{{ date('M j, Y  g:i A', strtotime($unit->updated_at)) }}
									</strong>
						  		</small>
						  		
						  	</p>
					</div>
				</div>

			{{-- End Card Footer --}}
			
			</div>
			<!-- End Card  -->
		</div>


		<div class="col col-12 col-md-4 mx-auto">
			<a href="{{ route('units.index') }}"><h2 class="bg-primary text-light text-center rounded p-2 ">VIEW UNITS</h2></a>
			<h2 class="bg-dark text-light text-center rounded p-2 ">STATISTICS</h2>
			<div class="table-responsive rounded">
				<table class="table table-hover ">
					<thead>
						<th class="text-center">LEGEND</th>
						<th class="text-center">FIGURE</th>
					</thead>
					<tbody>

						<tr class="{{ $color }}">
							<td><strong>Status</strong></td>
							<td>{{ strtoupper($unit->status->name) }}</td>
						</tr>
						<tr>
							<td>Last Rented Date</td>
							<td>{Rented Date}</td>
						</tr>
						<tr>
							<td>Last Used By</td>
							<td>{Rented User}</td>
						</tr>
						<tr>
							<td>Total Times Rented</td>
							<td>{20}</td>
						</tr>
						<tr>
							<td>Gross Income</td>
							<td>&#8369; {{ number_format(150000,2)  }}</td>
						</tr>
						
					</tbody>
				</table>
			</div>
		</div>



	</div>
</div>

@endsection